SystemOrganization addCategory: #Squeak2JS!

OMeta2 subclass: #S2JOMeta2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JOMeta2 subclass: #S2JAstReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JAstReader class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:10'!
convert: aString as: aSourceRule
	
	^ self convert: aString as: aSourceRule to: #translate! !

!S2JAstReader class methodsFor: 'converting' stamp: 'ag 12/8/2010 22:12'!
convert: aString as: aSourceRule to: aTargetRule
	
	^ self match: (self getInput: aString as: aSourceRule) with: aTargetRule! !

!S2JAstReader class methodsFor: 'converting' stamp: 'ag 12/8/2010 22:13'!
convertDebug: aString as: aSourceRule
	
	^ self debugMatch: (self getInput: aString as: aSourceRule) with: #translate! !

!S2JAstReader class methodsFor: 'private' stamp: 'ag 12/8/2010 22:12'!
getInput: aString as: aRule	
	
	^ self inputConverter convert: aString as: aRule! !

!S2JAstReader class methodsFor: 'converting' stamp: 'ag 12/8/2010 22:13'!
inputConverter
	"An AstReader should know, which converter-class can provide the ast wants to read"
	
	self subclassResponsibility! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/13/2010 17:41'!
hasSelector: aSymbol
	
	^ self class includesSelector: aSymbol! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/8/2010 10:53'!
translate =
	
	translateNamed(nil)! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:49'!
translateNamed :nodeName =
	
	translateNamedWith(nodeName. nodeName)! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/9/2010 17:05'!
translateNamedWith :nodeName :targetRule =
	
	translateNamedWithArgument(nodeName. targetRule. nil)! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/13/2010 17:41'!
translateNamedWithArgument :nodeName :targetRule :argument =
	
	// Lookahead for one node
	&anything:node
	
	// Some assertions, e.g. about the nodeName
	?[ node class = S2JNode ]
	?[ nodeName isNil | (node name = nodeName )]
	[ targetRule ifNil: [ node name asSymbol ] ifNotNil: [ targetRule asSymbol ]]:appliedRule
	?[ self hasSelector: appliedRule ]
	
	// If an argument is given, call the targetRule with that argument. Else, call the targetRule without arguments
	(( ?[ argument notNil ] { apply(appliedRule. argument):result } )
	| { apply(appliedRule):result })
	
	// Return the parsed content of the node
	-> [ result ]! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:03'!
translateWith :aRule =
	
	translateNamedWith(nil. aRule)! !

S2JAstReader subclass: #S2JAstToAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JAstToAst class methodsFor: 'converting' stamp: 'ag 12/8/2010 13:55'!
gatherInputFrom: aString withRule: aSourceRule
	
	^ S2JParser matchString: aString with: aSourceRule! !

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 11:56'!
passThroughAndTranslate =
	
	// TODO add all primitive values?..
	
	string // includes symbol
|	number
|	char
|	nil
|	{ translate*:children }:node
	-> [ self node: node name with: children ]! !

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:37'!
renameTo :nodeName =
	
	translate*:contents
	-> [ self node: nodeName with: contents ]! !

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:31'!
translate = 
	
	^translate
|	passThroughAndTranslate! !

S2JAstToAst subclass: #S2JJsAstOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JJsAstOptimizer class methodsFor: 'converting' stamp: 'ag 12/8/2010 21:30'!
inputConverter
	
	self error: 'The Js-Ast-Optimizer is not yet functional!!'.
	^ S2JSqueakToJsAst! !

!S2JJsAstOptimizer methodsFor: 'convert special cases' stamp: 'ag 12/8/2010 10:38'!
forLoop =
	// Special case of keywordExpression
	

	translate:receiver symbol:selector translate*:arguments
	?[ selector = #do: ]
	?[ arguments size = 1 ]
	[ arguments first ]:block
	?[ block size >= 1 ]
	?[ block first name = 'arguments' ]
	?[ block first size = 1 ]
	-> [ self forLoopOver: receiver do: block ]! !

!S2JJsAstOptimizer methodsFor: 'convert special cases' stamp: 'ag 12/8/2010 11:03'!
forLoopOver: anArrayNode do: aBlockNode

	| arrayName statements aStatementsNode aTemporariesNode loopVariableName |
	arrayName := 'arr$'.
	loopVariableName := aBlockNode first first.
	aStatementsNode := aBlockNode detect: [:each | each name = 'statements'] ifNone: [ nil ].
	aTemporariesNode := aBlockNode detect: [:each | each name = 'temporaries'] ifNone: [ nil ].
	aStatementsNode ifNotNil: [ statements := self apply: #translate withArgs: aStatementsNode].
	^self node: 'statements' with:
		{self node: 'variableDeclaration' with:
			{self node: 'identifier' with: { arrayName }.
			  self node: 'expression' with: anArrayNode}.
		 self node: 'forLoop' withoutNils:
			{self node: 'identifier' with: { arrayName }.
			loopVariableName.
			aTemporariesNode.
			statements}}! !

!S2JJsAstOptimizer methodsFor: 'convert complex' stamp: 'ag 12/8/2010 13:54'!
keywordExpression = 
	
	forLoop
|	messageSendExpression // ...not correct ...
! !

S2JAstToAst subclass: #S2JSqueakAstToJsAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JSqueakAstToJsAst class methodsFor: 'rules' stamp: 'ag 12/9/2010 16:44'!
cascadeReceiver
	
	^ 'cascadeReceiver$'! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'ag 12/9/2010 16:58'!
functionCallFor: aSelector of: aReceiver
	"Return association from receiver to function-name"
	
	| functionName receiverString |
	functionName := self squeakSelectorToJSFunctionName: aSelector.
	receiverString := aReceiver.
	(aReceiver first = JsGlobal name asString)
		ifTrue: [
			receiverString := nil.
			functionName := self globalObjectMethodFor: aSelector].
	^ receiverString -> functionName! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-globals' stamp: 'ag 12/8/2010 21:25'!
globalMethodNames
	
	^ Dictionary newFrom:
		{ 'alert:' ->  'alert' }! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-globals' stamp: 'ag 12/8/2010 21:24'!
globalObjectMethodFor: aString
	
	^ self globalMethodNames
		at: aString
		ifAbsent: [self squeakSelectorToJSFunctionName: aString]! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 12/8/2010 13:57'!
indentifierForSqueakCharacter: aCharacter 
	
	^ self
		squeakCharacterToJSIdentifier
		at: aCharacter ifAbsent: [nil]! !

!S2JSqueakAstToJsAst class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:14'!
inputConverter
	
	^ S2JParser! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 12/8/2010 13:57'!
squeakCharacterToJSIdentifier
	"Several characters can be used for selectors in squeak but
	are not allowed for JavaScript functionname"
	
	^ Dictionary newFrom:
		{$: -> '$'. 
		$+ -> '$plus'.
		$- -> '$minus'.
		$* -> '$times'.
		$/ ->  '$slash'.
		$\ -> '$backslash'.
		$~ -> '$tilde'.
		$< -> '$less'.
		$> -> '$greater'.
		$= -> '$equals'.
		$@ -> '$at'.
		$% -> '$percent'.
		$& -> '$and'.
		$? -> '$question'.
		$!! -> '$exclamation'.
		$` -> '$backtick'.
		$, -> '$comma'. 
		$| -> '$pipe'}! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 12/8/2010 13:57'!
squeakSelectorToJSFunctionName: aStringOrSymbol	
	
	| result |
	result := ''.
	aStringOrSymbol asString do: [ :each || jsIdentifier |
		jsIdentifier := self indentifierForSqueakCharacter: each.
		jsIdentifier
			ifNotNil: [result := result, jsIdentifier ]
			ifNil: [result := result, each asString]].
	^ result! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 12/13/2010 17:52'!
squeakToJSKeyword: aString
	"Uncovered keywords: thisContext, homeContext, super"
	
	"TODO cannot translate some of the keywords below!!... just stubs!!"
	
	^ aString
		caseOf: {
			[ 'self' ] -> [ 'this' ].
			[ 'true' ] -> [ 'true' ].
			[ 'false' ] -> [ 'false' ].
			[ 'nil' ] -> [ 'NULL' ].
			[ 'super' ] -> [ 'SUPER' ].
			[ 'superContext' ] -> [ 'SUPER_CONTEXT' ].
			[ 'thisContext' ] -> [ 'THIS_CONTEXT' ].
		}
		otherwise: [ self error: 'Cannot translate keyword to JS: ', aString ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 13:07'!
arguments =
	
	renameTo('arguments')! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/8/2010 12:56'!
array =
	// Pack inner nodes in expression-nodes
	
	translate*:elements
	-> [ self node: 'array' with: (elements collect: [ :each | self node: 'expression' with: { each } ])]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/8/2010 12:55'!
binaryExpression =
	
	messageSendExpression! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 13:07'!
block =
	
	translateNamed('arguments')?:arguments
	translateNamed('temporaries')?:temporaries
	translateNamedWith('statements'. #blockStatements)?:statements
	-> [ self blockWithArgs: arguments andTemps: temporaries andBody: statements ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 17:39'!
blockStatements =
	
	// Rename all returnExpressions to nonlocalReturnExpressions
	(
		(translate:expression
		[ expression name = 'returnExpression' ifTrue: [ expression name: 'nonlocalReturnExpression' ]])
		-> [ expression ]
	)*:expressions
	
	// If the last expression was no returnExpressions (has not been renamed above), turn it into a returnExpression
	[ expressions ifNotEmpty: 
		[ expressions last name = 'nonlocalReturnExpression' ifFalse: 
			[ expressions last name: 'returnExpression' ]]]
	
	-> [ self node: 'statements' with: expressions ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/13/2010 19:12'!
blockWithArgs: arguments andTemps: temps andBody: statements
	
	| functionArguments functionBody |
	functionBody := self combineStatements: statements withFirst: temps.
	temps ifNotNil: [ functionBody addFirst: temps ].
	functionArguments := arguments ifNotNil: [ arguments ] ifNil: [ self node: 'arguments' ].
	^ self node: 'functionDeclaration' withoutNils: { functionArguments. functionBody }! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 12:38'!
braceExpression =
	
	renameTo('array')! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/9/2010 13:48'!
byteArray =
	
	translate*:elements
	-> [ self node: 'array' with: (elements collect: 
		[ :each | self node: 'expression' with: { self node: 'number' with: { each }} ])]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 16:48'!
cascadedExpression =
	
	translate:receiver
	translateNamedWithArgument(nil. #messageSendExpression. self node: 'identifier' with: { self class cascadeReceiver })*:functions
	-> [ self cascadedExpression: functions to: receiver ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:51'!
cascadedExpression: functions to: receiver
	"This will be a nested statements-node inside the parent-statements-node of this cascadedExpression"
	
	| statements |
	statements := self node: 'statements' with: 
		{ self node: 'variableDeclaration' with: { self node: 'identifier' with: { 'cascadeReceiver$' }. 
		self node: 'assignment' with: { receiver } } }.
	functions do: [ :each | statements add: (self node: 'expression' with: { each })].
	^ statements! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/13/2010 19:21'!
combineStatements: aNode withFirst: anElement
	
	^ self combineStatements: aNode withFirst: anElement and: nil! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/13/2010 19:21'!
combineStatements: aNode withFirst: anElement and: anotherElement
	
	| result |
	result := aNode ifNil: [ self node: 'statements' ] ifNotNil: [ aNode ].
	anElement ifNotNil: [ result addFirst: anElement; yourself ].
	anotherElement ifNotNil: [ result addFirst: anotherElement; yourself ].
	^ result! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 16:12'!
doItSnippet =
	
	methodContent! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:29'!
functionCall: selector to: receiver withArguments: arguments
	
	| functionCallAssociation |
	functionCallAssociation := self class functionCallFor: selector of: receiver.
	^ self node: 'functionCall' with: {
			functionCallAssociation key.
			functionCallAssociation value.
			self node: 'arguments' with: arguments }! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/8/2010 13:53'!
keywordExpression = 
	
	messageSendExpression! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 19:07'!
messagePattern =
	
	^symbol:selector translate*:arguments
	-> [ self node: 'header' with: { self class squeakSelectorToJSFunctionName: selector }, arguments ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:30'!
messageSend :receiver =
	// Not a name of a node, but a generic rule for a message send, excluding the receiver.
	// The receiver is passed as argument (as translated JS-String), so it has to be read first.
	
	^symbol:selector translate*:arguments
	-> [ self functionCall: selector to: receiver withArguments: arguments ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/8/2010 12:56'!
messageSendExpression =
	
	translate:receiver messageSend(receiver):result
	-> [ result ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 19:16'!
method =
	
	translateWith(#messagePattern):header
	methodContent:statements
	-> [ self node: 'method' with: { header. statements }]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 19:21'!
methodContent =
	
	translateNamed('temporaries')?:temporaries
	translateNamed('primitiveDeclaration')?:primitiveDeclaration
	translate?:statements
	-> [ self combineStatements: statements withFirst: temporaries and: primitiveDeclaration ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 19:17'!
primitiveDeclaration =
	
	renameTo('primitiveDeclaration')! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/8/2010 14:41'!
reservedWord =
	
	^string:keyword
	-> [ self node: 'reservedWord' with: { self class squeakToJSKeyword: keyword } ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 13:37'!
temporaries =
	
	renameTo('variableDeclaration')! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/8/2010 12:55'!
unaryExpression =
	
	messageSendExpression! !

S2JAstReader subclass: #S2JPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JPrinter class methodsFor: 'converting' stamp: 'ag 12/9/2010 11:41'!
inputConverter
	
	^ S2JSqueakAstToJsAst! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 14:44'!
arguments =
	
	translate*:identifiers
	-> [ self functionParameters: identifiers ]! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/8/2010 14:46'!
array = 
	
	translate*:contents
	-> [ '[', (S2JNode concatenate: contents separatedBy: ', '), ']' ]! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/2/2010 11:33'!
asJSString: aString
	
	^ '"', aString, '"'! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/9/2010 16:19'!
assignment =
	
	translate! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/13/2010 19:27'!
character =
	
	// TODO Squeak-characters always applicable in JS ?
	
	char:result
	-> [ self asJSString: result asString ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 14:45'!
expression =
	
	translate:expressionBody translate*:assignments
	-> [ self expression: expressionBody withAssignments: assignments ]! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:02'!
expression: anExpressionBodyString withAssignments: aStringCollection
	
	| expressionString |
	expressionString := ''.
	aStringCollection isEmpty
		ifFalse: [ expressionString := expressionString, (S2JNode concatenate: aStringCollection separatedBy: '='), '=' ].
	expressionString := expressionString, anExpressionBodyString.
	^ expressionString! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 15:00'!
functionCall =
	
	(nil | translate):receiver ^string:functionName translate:arguments
	-> [ self functionCall: functionName to: receiver withArguments: arguments ]! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:00'!
functionCall: aFunctionName to: aReceiverString withArguments: anArgumentsString
	
	^ (aReceiverString
		ifNotNil: [ aReceiverString, '.' ]
		ifNil: [ '' ])
			, aFunctionName, anArgumentsString! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/9/2010 15:54'!
functionDeclaration =
	
	translate:arguments
	translate:statements
	-> [ self functionDeclaration: arguments withBody: statements ]! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:02'!
functionDeclaration: aParameterString withBody: aStatementsString
	"aParameterString already contains the parantheses; #functionParameters: should be used."
	
	| functionBody |
	functionBody := ''.
	aStatementsString ifNotNil: [ functionBody := functionBody, aStatementsString].
	^ 'function', aParameterString, '{', functionBody, '}'! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:05'!
functionParameters: aStringCollection
	
	^ '(', (S2JNode concatenate: aStringCollection separatedBy: ', '), ')'! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/13/2010 18:59'!
hasSelector: aSymbol
	"This is not allowed in the printer, it must understand all the symbols!!"
	
	^ (super hasSelector: aSymbol)
		ifTrue: [ true ]
		ifFalse: [ self error: 'Unknown selector: ', aSymbol asString. false ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 14:14'!
header =
	
	^string:functionName arguments:arguments
	-> [ functionName -> arguments ]! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/2/2010 11:52'!
identifier =
	
	^string:identifier
	-> [ identifier ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 18:16'!
method =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withBody: statements) ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:35'!
nonlocalReturnExpression =
	
	// TODO implement this!!
	
	returnExpression! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/6/2010 21:38'!
number =
	
	// TODO check, whether these methods always yield in correct JS-number-code-literals !!!!
	
	^number:number
	-> [ number isInteger
		ifTrue: [ number asString ]
		ifFalse: [ number asFloat asString ]]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:43'!
paranthesizedExpression =
	
	translate:value
	-> [ '(', value, ')' ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:50'!
primitiveDeclaration =
	
	// TODO not implemented yet!!
	
	anything // actual value ignored for now
	functionCall(nil. 'primitiveCall'. self node: 'arguments'):result
	-> [ result ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:37'!
reservedWord =
	
	^string! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 18:55'!
returnExpression =
	
	expression:value
	-> [ 'return ', value ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 18:51'!
statements =
	
	translate*:expressions
	-> [ S2JNode concatenate: expressions separatedBy: ';' ]! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/2/2010 11:34'!
string =
	
	^string:string
	-> [ self asJSString: string ]! !

!S2JPrinter methodsFor: 'translate tokens' stamp: 'ag 12/6/2010 21:38'!
symbol =
	// Symbols are translated to JS-strings
	
	^symbol:s
	-> [ self asJSString: s asString ]! !

!S2JPrinter methodsFor: 'translate complex' stamp: 'ag 12/9/2010 16:19'!
variableDeclaration =
	
	translateNamed('identifier')+:variableNames translateNamed('assignment')?:assignment
	-> [ self variableDeclaration: variableNames withAssignment: assignment ]! !

!S2JPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:51'!
variableDeclaration: variableNames withAssignment: assignment
	"Acts as an expression, not terminated by a semi colon"
	
	| result |
	variableNames size = 1
		ifTrue: [
			result := 'var ', variableNames first.
			assignment ifNotNil: [
				result := result, '=', assignment]]
		ifFalse: [
			result := 'var ', (S2JNode concatenate: variableNames separatedBy: ';var '), ';'.
			assignment ifNotNil: 
				[ result := result, (S2JNode concatenate: variableNames separatedBy: '='), '=', assignment ]].
	^ result! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
classNamed: aClassOrClassname
	
	^ Smalltalk classNamed: aClassOrClassname asString! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:09'!
convert: aString as: aRule
	
	self subclassResponsibility! !

!S2JOMeta2 class methodsFor: 'tests' stamp: 'ag 12/13/2010 11:53'!
convertAllMethods
	"Convert all methods in this image, print errors to the Transcript, notify every 500 methods"
	
	| converted succeeded total |
	converted := -1.
	succeeded := 0.
	total := Smalltalk allClasses inject: 0 into: [ :sum :each | sum + each methodDict size].
	Transcript cr; show: 'Trying to convert ', total asString, ' methods...' .
	[ Smalltalk allClasses do: [ :eachClass |
		(self isClassParsableAndNotEmpty: eachClass)  ifTrue: [
			eachClass methodDict do: [ :eachMethod |
				[ converted := converted + 1. self convertCompiledMethod: eachMethod. succeeded := succeeded + 1.
				(converted \\ 500 = 0) ifTrue: [ Transcript cr; show: 'Converted ', converted asString, ' methods.' ]
				]
					on: Exception do: [ :err | Transcript cr; show: '	', converted asString, ': ', eachMethod name, ' (', err, ')' ]]]].
	]
		ensure: [ Transcript cr; show: 'Finished!! ', succeeded asString, ' of ', converted asString, ' method have been converted!!' ].! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 17:54'!
convertAllMethodsOf: aClass
	
	^ (self isClassParsableAndNotEmpty: aClass)
		ifTrue: [ | methods |
			methods := Dictionary new.
			aClass methodDict valuesDo:
				[ :method | | result |
					[ result := self convertCompiledMethod: method ]
						on: Exception do: [ :err | self error: 'Failed to convert ', method printString, ': ', err ].
					methods at: result key put: result value].
			methods]
		ifFalse: [ self error: 'Cannot convert class ', aClass name ]! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 21:43'!
convertCompiledMethod: aCompiledMethod
	"Before converting aCompiledMethod, check whether we can actually parse it."
	
	(self isMethodParsable: aCompiledMethod)
		ifFalse: [ self error: 'Cannot parse method, invalid compiler-class: ', aCompiledMethod printString ].
	^ self convertMethod: (self sourceOf: aCompiledMethod)! !

!S2JOMeta2 class methodsFor: 'converting debug' stamp: 'ag 12/8/2010 22:10'!
convertDebug: aString as: aRule
	
	self subclassResponsibility! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:06'!
convertDoIt: aString
	
	^ self convert: aString as: #doItSnippet! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:19'!
convertMethod: aString
	
	^ self convert: aString as: #method! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:20'!
convertMethod: aStringOrSymbol of: aClassOrClassname
	
	| method |
	method := self method: aStringOrSymbol of: aClassOrClassname.
	^ method
		ifNotNil: [ self convertCompiledMethod: method ]
		ifNil: [ self error: 'Method ', aStringOrSymbol asString, ' not found in class ', aClassOrClassname asString ]! !

!S2JOMeta2 class methodsFor: 'tests' stamp: 'ag 12/13/2010 08:44'!
convertRandomMethods: aNumber
	"Match some random methods from the image. Return a String summarizing the result.
	Failed methods are printed to the Transcript."
	
	| runs successes |
	runs := successes := 0.
	aNumber timesRepeat: 
		[ | method |
			method := self randomMethod.
			method ifNotNil: [
				[ runs := runs + 1. S2JParser convertCompiledMethod: method. successes := successes + 1 ]
					on: Error do: [ :err | Transcript cr; cr; show: 'Failed to parse: ', method name, '. ', err ]]].
	^ runs asString, ' runs, ', successes asString, ' successes'! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:08'!
convertStatements: aString
	
	^ self convert: aString as: #statements! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:42'!
isClassParsable: aClass
	
	^ aClass compilerClass = Compiler! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:44'!
isClassParsableAndNotEmpty: aClass
	
	^ (self isClassParsable: aClass) and: [ aClass methodDict notEmpty ]! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:42'!
isMethodParsable: aCompiledMethod
	
	^ self isClassParsable: aCompiledMethod methodClass! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
method: aStringOrSymbol of: aClassOrClassname
	
	^ (self classNamed: aClassOrClassname)
		lookupSelector: aStringOrSymbol asSymbol! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 13:21'!
randomMethod
	"Methods, that don't work, e.g. because they are too long, are excluded."
	
	| class result |
	result := nil.
	[ result isNil ] whileTrue: [
		class := Smalltalk allClasses atRandom.
		(self isClassParsableAndNotEmpty: class)
			ifTrue: [ result := class methodDict atRandom ]].
	^ result! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 18:18'!
sourceOf: aCompiledMethod
	
	^ aCompiledMethod getSource asString! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 22:53'!
H =
	
	[ self halt ]! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 14:35'!
fail =
	
	?[ false ]! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/13/2010 12:48'!
nil =
	
	anything:object ?[ object isNil ]
	-> [ object ]! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:16'!
node: aString
	
	^ self node: aString with: {}! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString with: anOrderedCollection
	
	^ S2JNode named: aString with: anOrderedCollection! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString withoutNils: anOrderedCollection
	
	^ S2JNode named: aString withoutNils: anOrderedCollection! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString withoutNilsNotEmpty: anOrderedCollection
	
	^ S2JNode named: aString withoutNilsNotEmpty: anOrderedCollection! !

S2JOMeta2 subclass: #S2JParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JParser commentStamp: 'ag 12/7/2010 23:09' prior: 0!
tokens
	Rules, that read one single element in squeal source-code. They all don't return an S2JNode, all are parsed to the
	according Squeak-object (e.g. Number, Symbol, String).
	Spaces before and after the tokens in the source-code are NOT read!!
	This is because in some cases, tokens must be read exactly, without emitting any spaces.
	The things returned from here must not be converted anymore, especially the <> operator is unnecessary.
	
complex elements
	Bigger parts of squeak source-code. Most return an S2JNode (using #node:with:), which contains further complex elements or object read
	by rules in the tokens-protocol. As convention, the nodes (except for helper-rules like primary and messagePattern) should be named like the rules.
	Each rule is supposed to read spaces before applying itself!! This way, rules from this protocol can be called serially, without
	reading spaces inbetween. However, spaces must be read between single tokens.
	
helpers
	Squeak-methods, that are called from within ometa-rules (or helper-rules).
	OMeta2 return-parts of the rules (righthand of ->) cannot contain multiple expressions (?)...
!

!S2JParser class methodsFor: 'converting' stamp: 'ag 12/8/2010 21:36'!
convert: aString as: aRule
	
	| matcherToResult |
	matcherToResult := self matchStringWithoutEnd: aString with: aRule.
	matcherToResult key apply: #end.
	^ matcherToResult value! !

!S2JParser class methodsFor: 'converting' stamp: 'ag 12/8/2010 22:14'!
convertDebug: aString as: aRule
	
	| matcherToResult |
	matcherToResult := self matchStringWithoutEnd: aString with: aRule.
	[ matcherToResult key apply: #end ]
		on: OM2Fail do: [ :err | 
			matcherToResult value explore. 
			self error: err ].
	^ matcherToResult value! !

!S2JParser class methodsFor: 'converting private' stamp: 'LT 11/29/2010 12:50:54.628'!
matchStringWithoutEnd: aString with: aRule
	"Returns both the matcher and the result as an association."
	
	| matcher result |
	matcher := self matcherOn: aString readStream.
	result := matcher
		apply: #empty;
		apply: aRule.
	matcher apply: #spaces.
	^ matcher -> result! !

!S2JParser class methodsFor: 'parsing' stamp: 'ag 12/1/2010 11:04'!
parseNumber: aString
	"Parse aString to an instance of Number. Return nil, if parsing failed.
	Return nil also, if a number could be read, but not the whole String was processed.
	(Number readFrom: aString does not fail in that case)."
	
	| stream result |
	stream := ReadStream on: aString.
	result := Number readFrom: stream ifFail: [ nil ].
	stream atEnd ifFalse: [ result := nil ].
	^ result! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/9/2010 13:45'!
array =
	
	$(
		(
			(spaces
				(((($# spaces)? array:array) -> [ array ])
				| nodeNamed(#symbolBaseForArray. 'symbol')
				| literalTokenBase
				):element
			) -> [ element ]
		)*:contents
	ch($))
	-> [ self node: 'array' with: contents ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:10'!
binaryExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	spaces:comment binaryExpressionMessage:message
	-> [ self node: 'binaryExpression' withoutNils:
		{ self extractCommentOf: comment. receiver }, message ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:09'!
binaryExpressionMessage =
	// Not returning a node, but a simple collection
	
	binarySelector:selector
	(unaryExpression | primary):argument
	-> [ { selector. argument } ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/1/2010 13:32'!
binarySelector =
	
	<$| | ((specialCharacter | $-) specialCharacter*)>:selector
	-> [ selector asSymbol ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/8/2010 22:00'!
block =
	
	ch($[):comment1
		( (ch($:) spaces identifier:argumentName -> [ argumentName ])+:arguments ch($|)?:argumentSeparator )?
		temporaries?:temporaries
		statements?:statements
	ch($]):comment2
	
	// Forbidden (and not covered above): Arguments without separator bar, but with statements or temporaries
	?[ argumentSeparator notNil | arguments isNil | ((temporaries isNil or: [temporaries isEmpty]) & (statements isNil or: [statements isEmpty])) ]
	
	-> [ self node: 'block' withoutNils: { self extractCommentOf: comment1.
			self node: 'arguments' withoutNilsNotEmpty: arguments.
			temporaries. statements.
			self extractCommentOf: comment2} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'SW 11/30/2010 15:49'!
braceExpression =
	
	ch(${):comment1
		(expression:expr ch($.) -> [ expr ] )*:expressions
		expression?:lastExpression
	ch($}):comment2
	
	-> [ self braceExpressionWith: expressions and: lastExpression and: (self extractCommentOf:comment1,  comment2) ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 13:40'!
braceExpressionWith: expressions and: lastExpression and:comment
	
	^ self node: 'braceExpression' withoutNils: 
		((expressions
			ifNotNil: [ expressions ]
			ifNil: [ {} ])
				asOrderedCollection
					add: lastExpression;
					addFirst: comment;
					yourself)! !

!S2JParser methodsFor: 'parse easy' stamp: 'LT 12/6/2010 14:46:45.606'!
byteArray =
	
	$# ch($[)
		(
			(spaces number:number [ number first ]:byte
			?[ (byte isInteger) & (byte <= 255) & (byte >= 0)] 
			) -> [ byte ]
		)*:contents
	ch($])
	-> [ self node: 'byteArray' with: contents ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/2/2010 10:33'!
cascadedExpression =
	// Constructs a node, whose first node is the receiver and all further nodes are messages sent to that receiver
	
	(keywordExpression | binaryExpression | unaryExpression):mainExpression
	(
		ch($;):comment1
		(
		((spaces binarySelector:selector (unaryExpression | primary):argument) -> [ self node: 'binaryExpression' with: { selector. argument }])
		| (((spaces keyword:selector (binaryExpression | unaryExpression | primary):argument) -> 
				[ selector -> argument])+:selectorsAndArguments -> [ (self keywordMessage: selectorsAndArguments) name: 'keywordExpression' ])
		| (spaces unarySelector:selector -> [ self node: 'unaryExpression' with: { selector } ])
		):cascade
		-> [ cascade ]
	)+:cascades
	-> [ self cascadedExpression: mainExpression with: cascades ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 13:16'!
cascadedExpression: mainExpression with: cascades
	"The receiver of the mainExpression is the receiver of the whole cascade.
	It is the first node, the other nodes are the messages sent to that receiver"
	
	^ self node: 'cascadedExpression' withoutNils: 
		((cascades
			ifNotNil: [ cascades ]
			ifNil: [ {} ])
				asOrderedCollection
					addFirst: mainExpression;
					addFirst: mainExpression removeFirst;
					yourself)! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 11/30/2010 11:01'!
ch :c =
	// This reads a given element and all spaces before it and return the element
	// ch was supposed to mean character, but this can be applied to any object
	// Called like this: ch($=)
	
	spaces:comment exactly(c)
	-> [ comment ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 10:48'!
character =
	// The method in the super class is #char, don't confuse it!!
	
	( ($$ <anything>:value) | (seq('Character space') -> [ $  ]):value )
	-> [ self node: 'character' with: { value asCharacter } ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 15:13'!
consumedBy: aBlock
	
	| result |
	result := super consumedBy: aBlock.
	result isString
		ifFalse: [ result := S2JNode concatenate: result separatedBy: '' ].
	^ result! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 16:34'!
doItSnippet =
	
	temporaries?:temps
	statements?:statements
	-> [ self node: 'doItSnippet' withoutNils: { temps. statements } ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/2/2010 09:41'!
expression =
	
	((spaces identifier:identifier (token(':=') | ch($_))) -> [ identifier ])*:variableNames 
	(cascadedExpression | keywordExpression | binaryExpression | unaryExpression | primary):expressionBody
	
	// First child is the expressionBody, further children are names of variables, that are assigned by this expression
	-> [ self node: 'expression' withoutNils: ({ expressionBody }, variableNames) ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/1/2010 13:34'!
extractCommentOf: anOrderedCollection
	
	| result |
	result := ''.
	anOrderedCollection do: [:item |
		item name = 'comment' ifTrue: [
			result := result , item first
			]].
	^ result isEmpty
		ifTrue: [nil]
		ifFalse: [self node: 'comment' with:{result}]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 11:29'!
identifier =
	
	nodeNamed(#identifierBase. 'identifier')! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/30/2010 11:03'!
identifierBase =
	
	<letter letterOrDigit*>! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/22/2010 16:34'!
keyword =
	
	<identifierBase $:>:selector
	-> [ selector asSymbol ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:06'!
keywordExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	keywordExpressionMessage:message
	-> [self node: 'keywordExpression' with: { receiver }, message ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:06'!
keywordExpressionMessage =
	
	(((spaces keyword:selector ( binaryExpression | unaryExpression | primary ):argument) -> [ selector -> argument ])+:selectorAndArguments)
	-> [ self keywordMessage: selectorAndArguments ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/2/2010 10:31'!
keywordMessage: selectorAndArgumentNames
	"selectorAndArgumentNames contains associations, the part of the selector and the argument name.
	Resulting S2JNode will have the selector as symbol on the first position and the argumentNames at the other positions."
	
	| selector result |
	selector := ''.
	result := self node: 'keyword' with: {}.
	selectorAndArgumentNames do: [ :each |
		selector := selector, each key.
		result add: each value].
	^ result
		addFirst: selector asSymbol;
		yourself! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 15:23'!
literalToken =
	// Anything, that can be evaluated to an object without context
	
	literalTokenBase
|	(($# spaces array:array) -> [ array ])! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/7/2010 15:23'!
literalTokenBase =
	// Things, that can be evalutated to an object without any context (array-literals excluded)
	
	number
|	symbol
|	character
|	string
|	byteArray! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 13:56'!
messagePattern =
	
	((spaces keyword:selectorPart spaces identifier:argumentName) -> [ selectorPart -> argumentName ])+:selectorAndArgumentNames
	-> [ self keywordMessage: selectorAndArgumentNames ]
|	spaces binarySelector:selector spaces identifier:argumentName
	-> [ self node: 'binary' with: { selector. argumentName } ]	
|	spaces unarySelector:unarySelector
	-> [ self node: 'unary' with: { unarySelector } ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 09:11'!
method =
	// Only one temporaries-declaration allowed, but can be before or after primitive-declaration
	
	messagePattern:head
	temporaries?:temps
	primitiveDeclaration*:primitives
	temporaries?:secondTemps ( ?[secondTemps isNil]  | (?[temps isNil] [secondTemps]:temps) )
	statements?:statements
	
	-> [ self node: 'method' withoutNils: { head. temps }, primitives, { statements } ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 11:10'!
node :aRule =
	// Helper rule to encapsulate the result of a rule into a node
	// Resulting node is named like the rule
	
	nodeNamed(aRule. aRule asString)! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 11:10'!
nodeNamed :aRule :aNodeName =
	// Helper rule to encapsulate the result of a rule into a node
	
	apply(aRule):result
	-> [ self node: aNodeName asString with: { result } ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'LT 12/6/2010 14:37:16.251'!
number =
	// Called that way because of super-class-method
	// The string is parsed once, assuring, that
	
	<
		($-? digit+ $r)?
		$-?
		(digit | upper)+
		($. (digit | upper)+)?
		($e ($- | $+)? (digit | upper)+)?
	>:result
	?[ (self class parseNumber: result) notNil ]
	-> [ self node: 'number' with: {self class parseNumber: result} ]
	
	// An alternative way to evaluate a number...
	| ($# <digit>:value) -> [ self node: 'number' with: {value asNumber} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 15:24'!
primary =
	// something, that evaluates to an object
	
	spaces (literalToken | reservedWord | identifier):result -> [ result ]
|	block
|	braceExpression
|	token('(') expression:expr token(')') -> [ expr name: 'paranthesizedExpression'; yourself ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 13:40'!
primitiveDeclaration =
	// Reads generally all primitive declarations, there are many of them
	// <primitive: 'a'> <primitive: 2> <primitive: 'a' module: 'b'> <version: 'ab'> <command> etc. etc.
	
	ch($<)
		(
			primitiveDeclarationRule(#keywordExpressionMessage)
			| (space primitiveDeclarationRule(#binaryExpressionMessage))
			| primitiveDeclarationRule(#unaryExpressionMessage)
		):message
	ch($>)
	-> [ self node: 'primitiveDeclaration' with: { message } ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 15:34'!
primitiveDeclarationRule :aRule =
	// Read everything, that is inside the <>-primitive-declaration; write it back on the input stream, followed
	// by input, that will not be matched. Apply the rule and read the fake-input. Return the result after applying the rule.
	
	// This allows things, that are forbidden, like <primive: a> (a is an identifier and has been accepted, because it's also a unarySelector
	
	<
		((
			<spaces (literalToken | unarySelector | binarySelector | keyword)>:input ?[ (input includesSubString: '>') not ]
		) -> [ input ])*
	>:primitiveInput
	[ self apply: aRule withArgs: primitiveInput, '^^']:result
	$^ $^
	-> [ result ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/13/2010 17:30'!
reservedWord =
	
	<(seq('true') | seq('false') | seq('nil') | seq('self') | seq('super') | seq('thisContext') | seq('homeContext'))>:reservedWord
	&(binarySelector | space | end | $] | $.) // Look ahead to ensure, that this token ends here, don't match e.g. self2, but match self/2
	-> [ self node: 'reservedWord' with: { reservedWord }]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/13/2010 18:57'!
space =
	// A comment is equivalent to a space-character.
	// spaces are ignored (return nil), but comments result in a special node and are collected
	
	^space -> [ nil ]
	| (($" <(~$" anything)*>:result $") -> [ self node: 'comment' with: { result } ])! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/21/2010 13:46'!
specialCharacter =
	
	$+ | $* | $/ | $\ | $~ | $< | $> | $= | $@ | $% | $& | $? | $!! | $` | $,! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 18:58'!
statements =
	
	(expression?:expr ch($.) -> [ expr ] )*:expressions
	(ch($^)?:returnSign expression:lastExpression ch($.)? ~expression)?
	-> [ self statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 15:41'!
statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign
	"Build the contents of a statements-node from the information gathered while parsing 'statements'"
	
	"Rename the last expression, if it was a return-expression"
	lastExpression notNil & returnSign notNil ifTrue: [ lastExpression name: 'returnExpression' ].
	expressions
		add: lastExpression;
		reject: [ :each | each isNil ].
	^ self node: 'statements' withoutNilsNotEmpty: expressions! !

!S2JParser methodsFor: 'parse easy' stamp: 'mh 12/11/2010 00:38'!
string =
	// Called that way because of super-class-method
	
	$' ((~$' anything) | (($' $') -> [ $' ]))*:values $'
	-> [ self node: 'string' with: { values asOrderedCollection inject: '' into: [ :a :b | a, b asString ] } ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 17:23'!
symbol =
	
	$# spaces (symbolBase | (string:stringSymbol -> [ stringSymbol first ])):value 
	-> [ self node: 'symbol' with: { value asSymbol } ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/9/2010 13:41'!
symbolBase =
	// This does not return a symbol, just consume input. Inside of array, symbols can be represented without
	// the #-character
	
	binarySelector
|	<keyword+ identifierBase>
|	<keyword+>
|	identifierBase
|	($: | $. | ($[ $]) | ${ | $} | $^):result -> [ result asSymbol ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/9/2010 13:45'!
symbolBaseForArray =
	
	symbolBase
|	$[
|	$]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 11/21/2010 19:10'!
temporaries =
	
	ch($|)
		(spaces identifier:identifier -> [ identifier ])*:variableNames
	ch($|)
	-> [ self node: 'temporaries' with: variableNames ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:07'!
unaryExpression =
	
	(unaryExpression | primary):receiver unaryExpressionMessage:message
	-> [ self node: 'unaryExpression' with: {receiver. message} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:07'!
unaryExpressionMessage =
	
	spaces unarySelector:message
	-> [ message ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/2/2010 11:51'!
unarySelector =
	
	identifierBase:selector ~$:
	-> [ selector asSymbol ]! !

TestCase subclass: #S2JAbstractTest
	instanceVariableNames: 'currentRule nilResultAllowed checkResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:15'!
converterClass
	
	self subclassResponsibility! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultCheckResults
	
	^ true! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:24'!
defaultCurrentRule
	
	^ nil! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultNilResultsAllowed
	
	^ false! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:29'!
assert: aString matches: aRule
	"In most cases, throws an error when failing (hard fail)"
	
	| result |
	result := self class converterClass convert: aString as: aRule.
	self nilResultAllowed ifFalse: [ self assert: result notNil ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:17'!
assert: aString matches: aRule andProduces: anObject
	"In most cases, throws an error when failing (hard fail). #= Checks collections deeply."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = anObject ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/13/2010 08:46'!
assert: aString matches: aRule andProducesNode: aCollection
	"Matches the string to the rule and compares the result to an S2JNode containing the given collection and named like the rule.
	(Follows a convention)."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = (self node: aRule asString with: aCollection) ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString
	"Checks against the currentRule"
	
	self
		assertFails: aString
		toMatch: self currentRule.! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString toMatch: aRule
	
	self
		should: [ self assert: aString matches: aRule ]
		raise: OM2Fail
		description: 'Matching should have failed but didn''t!!'.! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString
	"Check against the currentRule"
	
	self assert: aString matches: self currentRule.! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProduces: anObject
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProduces: anObject! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProducesNode: aCollection
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProducesNode: aCollection! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults
	^ checkResults! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults: aBoolean
	checkResults := aBoolean! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule
	^ currentRule! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule: aSymbol
	currentRule := aSymbol! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:18'!
exampleMethod1
	
	"Comment"
	self class.
	^ [ JsGlobal alter: 'example'].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:18'!
exampleMethod2
	
	| temporaries |
	< primitiveDecl: 1 >
	"Comment"
	self class.
	self
		a: 1;
		b: 2;
		c.
	^ [ JsGlobal alter: 'example'].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:22'!
""exampleMethod3""
	""
	""<"" primitiveDecl: ""1 "">""
	""
	""| ""temporariesAfterPrimitiveDecl"" |""
	"Comment"
	""self"" class"".""
	self""
		""a:"" 1"";""
		""b: ""2"";""
		""c"".""
	""^"" [""JsGlobal ""alter:"" 'example'""]"".""! !

!S2JAbstractTest methodsFor: 'initialization' stamp: 'ag 12/13/2010 09:24'!
initialize
	
	super initialize.
	self
		nilResultAllowed: self class defaultNilResultsAllowed;
		checkResults: self class defaultCheckResults;
		currentRule: self class defaultCurrentRule.! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
nilResultAllowed
	^ nilResultAllowed! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
nilResultAllowed: aBoolean
	nilResultAllowed := aBoolean! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
node: aString
	
	^ S2JNode named: aString with: {}! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
node: aString with: aCollection
	
	^ S2JNode named: aString with: aCollection! !

!S2JAbstractTest methodsFor: 'private' stamp: 'ag 12/13/2010 09:30'!
performTest
	
	self class = S2JAbstractTest
		ifTrue: [ "Just ignore the abstract tests" ]
		ifFalse: [ super performTest ].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:20'!
testExampleMethods
	
	self class converterClass
		convertMethod: #exampleMethod1 of: self class;
		convertMethod: #exampleMethod2 of: self class;
		convertMethod: #exampleMethod3 of: self class.! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:49'!
testRandomMethods
	"Match some random methods from the image.
	Test will not fail, just print errors to the transcript, as this is no real test-case..."
	
	| result |
	result := self class converterClass convertRandomMethods: 10.
	Transcript cr; cr; show: self class name, ': ', result.! !

S2JAbstractTest subclass: #S2JParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JParserTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:24'!
converterClass
	
	^ S2JParser! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 17:16'!
testArray
	
	self
		currentRule: #array;
		
		assertMatches: '()' andProducesNode: {};
		assertMatches: '(:)' andProducesNode: { self node: 'symbol' with: { #: } };
		assertMatches: '(  )  ' andProducesNode: {};
		assertMatches: '( 2. 1) ';
		assertMatches: '( 2. 1 [ ] ^ 23 { } ) ';
		assertMatches: '(  1 2   3) ' andProducesNode: 
			{self node: 'number' with:{1}. self node: 'number' with:{2}. self node: 'number' with:{3}};
		assertMatches: '(''aa'' 1 ''b1'' 32)' andProducesNode: 
			{self node: 'string' with: { 'aa' }. self node: 'number' with: {1}. self node: 'string' with: { 'b1' }. self node: 'number' with: {32}};
		assertMatches: '(#abc     11    ''a''   )' andProducesNode: 
			{self node: 'symbol' with: {#abc}. self node: 'number' with: {11}. self node: 'string' with: {'a'}};
		assertMatches: '(  ( 1 2 3    ''2'')   #a  ''c''   )' andProducesNode: 
			{self node: 'array' with: {self node: 'number' with: {1}. self node: 'number' with: {2}. self node: 'number' with: {3}. self node: 'string' with: { '2' }}.
			self node: 'symbol' with: {#a}. self node: 'string' with: {'c'}};
		assertMatches: '($a     11    ''a''   #a2   #(1 2   $2) )  ' andProducesNode: { self node: 'character' with: { $a }. self node: 'number' with: {11}. self node: 'string' with: {'a'}. self node: 'symbol' with: {#a2}. self node: 'array' with: {self node: 'number' with: {1}. self node: 'number' with: {2}. self node: 'character' with: { $2 }}};
		assertMatches: '( a )' andProducesNode: { self node: 'symbol' with: {'a'}};
		assertMatches: '( a b )' andProducesNode: {self node: 'symbol' with: {'a'}. self node: 'symbol' with: {'b'}} ;
		assertMatches: '(d ((b ((a))) (c)))' andProducesNode: {self node: 'symbol' with: {'d'}. self node: 'array' with: {self node: 'array' with: {self node: 'symbol' with: {'b'}. 
			self node: 'array' with: {self node: 'array' with: {self node: 'symbol' with: {'a'}}}}. self node: 'array' with: {self node: 'symbol' with: {'c'}}}};
		assertMatches: '( self a:bc == |? ?!!!! )  ' andProducesNode: {self node: 'symbol' with: {'self'}. self node: 'symbol' with: {'a:bc'}. 
			self node: 'symbol' with: {'=='}. self node: 'symbol' with: {'|'}. self node: 'symbol' with: {'?'}. self node: 'symbol' with: {'?!!!!'}};
		assertMatches: '( self #( aa 1 ) ( ''a'' #1 #ab: ab:))  ' andProducesNode: { self node: 'symbol' with: {'self'}. self node: 'array' with: {self node: 'symbol' with: {'aa'}. self node: 'number' with: {1}. }. self node: 'array' with: { self node: 'string' with: { 'a' }. self node: 'number' with: {1}. self node: 'symbol' with: {'ab:'}. self node: 'symbol' with: {'ab:'} }} ;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '(';
		assertFails: '#()';
		assertFails: '#(';
		assertFails: '{1}';
		assertFails: ' ( 1 2  )'. "Should not read prepended spaces"! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 10:08'!
testBinaryExpression
	
	self
		currentRule: #binaryExpression;
		
		assertMatches: 'a+b' andProducesNode:  (self node:'binaryExpression' with: { self node: 'identifier' with: {'a'} . #+. self node: 'identifier' with: {'b'}} );
		assertMatches: '1 * b' andProducesNode: (self node:'binaryExpression' with: 
			{self node: 'number' with: {1} .#* . self node: 'identifier' with: {'b'}});
		assertMatches: '1 "Comment "* b' andProducesNode: (self node:'binaryExpression' with: 
			{ self node: 'comment' with:{ 'Comment ' } . self node: 'number' with: {1}. #*. 
			self node: 'identifier' with: {'b'}});
		assertMatches: '1 \ b / c' andProducesNode: 
			(self node: 'binaryExpression' with: 
				{ self node: 'binaryExpression' with: {  self node: 'number' with: {1} .  #\  . 
				self node: 'identifier' with: {'b'}} . #/ . self node: 'identifier' with: {'c'}} );
		
		assertFails: 'a 2';
		assertFails: 'a: 2';
		assertFails: '+ 2'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 11/21/2010 20:02'!
testBinarySelector
	"Would be cool to find all the binary messages in the image and test them..."
	
	self
		currentRule: #binarySelector;
		
		"special cases: single pipe and single minus"
		assertMatches: '|' andProduces: #|;
		assertMatches: '-' andProduces: #-;
		
		"names starting with a minus"
		assertMatches: '-*' andProduces: #-*;
		assertMatches: '-***' andProduces: #-***;
		assertMatches: '-*%&' andProduces: #-*%&;
		assertMatches: '-*/\' andProduces: #-*/\;
		assertMatches: '-!!?' andProduces: #-!!?;
		assertMatches: '-==' andProduces: #-==;
		
		"mixed characters, check each one"
		assertMatches: '*+' andProduces: #*+;
		assertMatches: '/=\' andProduces: #/=\;
		assertMatches: '~,,,<' andProduces: #~,,,<;
		assertMatches: '>@' andProduces: #>@;
		assertMatches: '%&' andProduces: #%&;
		assertMatches: '?!!' andProduces: #?!!;
		assertMatches: '``' andProduces: #``;
		assertMatches: '+??=' andProduces: #+??=;
		assertMatches: ',!!!!,' andProduces: #,!!!!,;
		
		"Not allowed things"
		assertFails: '';
		assertFails: ' ';
		assertFails: 'w';
		assertFails: '2';
		assertFails: '--';
		assertFails: '||';
		assertFails: '|--';
		assertFails: '%--';
		assertFails: '%||';
		assertFails: '&-&-';
		assertFails: '- %';
		assertFails: ' -';
		assertFails: '& &';
		assertFails: 'w a';
		assertFails: '- -';
		assertFails: '#a a';
		assertFails: '#aa 2'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 14:37'!
testBlock
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProducesNode: { };
		assertMatches: '[  ]' andProducesNode: { };
		assertMatches: '[||]' andProducesNode: {self node: 'temporaries'};
		assertMatches: '[:a|||]' andProducesNode: 
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries'};
		assertMatches: '[||a]' andProducesNode: {self node: 'temporaries'. self node: 'statements' with: {self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a|||a]' andProducesNode:
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries'. self node: 'statements' with: { self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a||a|a]' andProducesNode: 
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries' with: { self node: 'identifier' with: {'a'}}. 
			self node: 'statements' with: { self node: 'expression' with: { self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a|a|a|a]' andProducesNode:
			{ self node: 'arguments' with: { self node: 'identifier' with: {'a'} }. self node: 'statements' with:
				{ self node: 'expression' with: { self node: 'binaryExpression' with: { self node: 'binaryExpression' with: 
					{ self node: 'identifier' with: {'a'}. #|. self node: 'identifier' with: {'a'} }. #| . 
					self node: 'identifier' with: {'a'}.  }}}};
		assertMatches: '[ :a ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}}};
		assertMatches: '   [ :a ]  ' andProducesNode: {self node: 'arguments' with: { self node: 'identifier' with: {'a'}}};
		assertMatches: '[ :a :b ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}}};
		assertMatches: '[ :a  :b | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}}};
		assertMatches: '  [   :a |   |  a  |   ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. 
			self node: 'temporaries' with: {self node: 'identifier' with: {'a'}}};
		assertMatches: '[  :a  | a ]  ' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. 
			self node: 'statements' with: {self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[ :a  | a. ^ 1 ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'statements' with:
				{self node: 'expression' with: {self node: 'identifier' with: {'a'}}. self node: 'returnExpression' with: {self node: 'number' with: {1}}}};
		assertMatches: '[  :a  |  1  ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'statements' with: {self node: 'expression' with: {self node: 'number' with: {1}}}};
		assertMatches: '[  :b  |   []  ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'b'}}. self node: 'statements' with: {self node: 'expression' with: { self node: 'block'}}};
		
		assertMatches: '"aaaaa" "aaaa"[]'  andProducesNode: { self node:'comment' with: {'aaaaaaaaa' } };
		assertMatches: '"aaaaa" [ "a aaa"]'  andProducesNode: { self node:'comment' with: {'aaaaa' } . self node:'comment' with: {'a aaa' }};
		assertMatches: '[ "a aaa"] '  andProducesNode: { self node:'comment' with: {'a aaa' } };
		assertMatches: '[ "aaaa"] '  andProducesNode: { self node:'comment' with: {'aaaa' } };
		
		"Can also leave spaces between : and the argument-name !!"
		assertMatches: '[ :  i | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'i'}}};
		assertMatches: '[ :  i :  d | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'i'}. self node: 'identifier' with: {'d'}}};
		
		assertFails: '[]]';
		assertFails: '[[]';
		assertFails: '[::a]';
		assertFails: '[ :a | b';
		assertFails: '[ :a |||| b]';
		assertFails: '[ | :a | b]';
		assertFails: '[ || :a | b]';
		assertFails: '[ :a || b]';
		assertFails: '[ :a | :b  ]';
		assertFails: '[ :a || :b|]';
		assertFails: '[ :a | b| :a]';
		assertFails: '[ :a :1 | b]';
		assertFails: '[ aaaa"] ';
		assertFails: '[ "aaa"a"] ';
		assertFails: '[ "aaaa] '.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'LT 12/6/2010 15:38:05.369'!
testBraceExpression
	
	self
		currentRule: #braceExpression;
		
		assertMatches: '{}' andProducesNode: { };
		assertMatches: '  {  }   ' andProducesNode: { };
		assertMatches: '{1}' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {1}}};
		assertMatches: '  {  11 }  ' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {11}}};
		assertMatches: '  {  11. }  ' andProducesNode: {self node: 'expression' with: { self node: 'number' with: {11}}};
		assertMatches: '{ 1.   2}' andProducesNode: {self node: 'expression' with: 
			{self node: 'number' with: {1}}. self node: 'expression' with: { self node: 'number' with: {2}}};
		assertMatches: '{1.2}' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {1.2}}};
		assertMatches: '{1. 2}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'number' with: {2}}};
		assertMatches: '{1. ''.'' .}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'string' with: { '.'}}};
		assertMatches: '{1  .  2  .}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'number' with: {2}}};
		
		assertMatches: '"aaa"{}' andProducesNode: { self node: 'comment' with: {'aaa' } };
		assertMatches: '"aaa"{ "bbb"}' andProducesNode: { self node: 'comment' with: {'aaabbb' } };			
		assertMatches: '{ "bbb"}' andProducesNode: { self node: 'comment' with: {'bbb' } };								
		
		assertFails: '.{}.';
		assertFails: '{1 .. 2}';
		assertFails: '{ 1  . 2 ..}';
		assertFails: '{.1.2}';
		assertFails: '{..1.}';
 		assertFails: '{ "bb}';
 		assertFails: '{ "b "   .  b"}'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/9/2010 13:40'!
testByteArray
	
	self
		currentRule: #byteArray;
		
		assertMatches: '#[1]' andProducesNode: {1};
		assertMatches: '#  [  1  ]  ' andProducesNode: {1};
		assertMatches: '#[]' andProducesNode: {};
		assertMatches: '#   [1 2 3 ]' andProducesNode: {1. 2. 3.};
		assertMatches: '#[255 000 000 123 255]' andProducesNode: {255. 0. 0. 123. 255};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#[ 1';
		assertFails: '  #[ 1 ]';
		assertFails: '# [ 1.2 ]';
		assertFails: '#[ 256 1 00]';
		assertFails: '#[ -1 ]';
		assertFails: '#[ +1 ]';
		assertFails: '#[ #[ 1 ] ]  ';
		assertFails: '#( 255 )'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 10:09'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		assertMatches: 'Transcript  show:2;cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier' with:{'Transcript'}.  self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unaryExpression' with:{#cr}});
		"assertMatches: 'Transcript  show:2 ""Comment"";cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier:' with:{'Transcript'}. self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unarayExpression' with:{self node:'comment' with:{'Comment'} . #cr} } );" "comments are not yet stored correctly"

		assertFails: 'Transcript  show:2 "Comment;cr';				
		assertFails: 'Transcript show:1'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 11:14'!
testCharacter
	
	self
		currentRule: #character;
		
		assertMatches: '$c' andProducesNode: { $c };
		assertMatches: '$&' andProducesNode: { $& };
		assertMatches: '$ ' andProducesNode: { $ };
		assertMatches: '$`' andProducesNode: { $` };
		assertMatches: 'Character space' andProducesNode: { $  };
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'a';
		assertFails: '`';
		assertFails: ' $a';
		assertFails: '$$$';
		assertFails: '$  a';
		assertFails: '$av';
		assertFails: '$ a'.! !

!S2JParserTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 16:54'!
testExpressionAssignment
	
	self
		currentRule: #expression;
		
		assertMatches: 'a' andProducesNode: {self node: 'identifier' with: {'a'}};
		assertMatches: 'a := b' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: '  a   :=   b  ' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: 'a := b := c := 1' andProducesNode: {self node: 'number' with: {1}. 
			self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}. self node: 'identifier' with: {'c'}};
		assertMatches: '  a    :=  b  :=  c :=   1' andProducesNode: {self node: 'number' with: {1}. 
			self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}. self node: 'identifier' with: {'c'}};
		assertMatches: 'a _ b' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: 'a := 1';
		assertMatches: 'a := b := 1';
		assertMatches: 'a := b := c := d';
		assertMatches: '   a     :=      a     ';
		assertMatches: '   a     _   1 ';
		assertMatches: 'a:=1';
		assertMatches: 'a:=1.0';
		assertMatches: 'a:=b:=1.0';
		assertMatches: 'a_v_1';
		
		assertFails: 'a : = b';
		assertFails: ' := b';
		assertFails: 'a := ';
		assertFails: 'a := b :=';
		assertFails: 'a := b := 1 := a';
		assertFails: 'a := := b   ';
		assertFails: 'a _ _ b';
		assertFails: 'a __ b';
		assertFails: 'a :=:= b';
		assertFails: 'a := b v := a';
		assertFails: 'a  b := a ';
		assertFails: 'a := 1 := b';
		assertFails: 'a: := b';
		assertFails: 'a: _ b';
		assertFails: 'a :_ b';
		assertFails: 'a := 1 := 2:=f';
		assertFails: 'a __ b';
		assertFails: 'a : = b'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:53.039'!
testIdentifier
	
	self
		currentRule: #identifier;
		
		assertMatches: 'abc' andProducesNode: {'abc'};
		assertMatches: 'a1' andProducesNode: {'a1'};
		assertMatches: '1' andProducesNode: {'1'};
		assertMatches: 'aaaaaaaa1233333' andProducesNode: {'aaaaaaaa1233333'};
		assertMatches: '' andProducesNode: {''};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 11/22/2010 11:30'!
testKeywordSelector
	
	self
		currentRule: #keyword;
		
		assertMatches: 'abc:' andProduces: #abc:;
		assertMatches: 'a1:' andProduces: #a1:;
		assertMatches: '1:' andProduces: #1:;
		assertMatches: 'aaaaaaaa1233333:' andProduces: #aaaaaaaa1233333:;
		assertMatches: ':' andProduces: #:;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc';
		assertFails: 'abc<<'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/13/2010 09:27'!
testMethod
	
	self
		currentRule: #method;
		
		assertFails: 'a |a| <p> |a|'. "Don't allow two temporaries-declarations"! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:08.233'!
testNumber
	
	self
		currentRule: #number;
		
		assertMatches: '1' andProducesNode: {1};
		assertMatches: '0' andProducesNode: {0};
		assertMatches: '123' andProducesNode: {123};
		assertMatches: '112345678' andProducesNode: {112345678};
		assertMatches: '000' andProducesNode: {0};
		assertMatches: '-000' andProducesNode: {0};
		assertMatches: '-1' andProducesNode: {-1};
		assertMatches: '-1.22' andProducesNode: {-1.22};
		assertMatches: '1.22e23' andProducesNode: {1.22e23};
		assertMatches: '122e23' andProducesNode: {12200000000000000000000000};
		assertMatches: '35r35' andProducesNode: {35r35};
		assertMatches: '-35r35' andProducesNode: {-35r35};
		assertMatches: '22r12.12' andProducesNode: {22r12.12};
		assertMatches: '22r12.12e12' andProducesNode: {22r12.12e12};
		assertMatches: '-22r-12.12e12' andProducesNode: {-22r-12.12e12};
		assertMatches: '22r-12.12e12' andProducesNode: {22r-12.12e12};
		assertMatches: '-22r12.12e12' andProducesNode: {-22r12.12e12};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '+1';
		assertFails: '+1.2';
		assertFails: '+23r23.3';
		assertFails: '+23r+233.3';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: 'abc';
		assertFails: '<<'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/13/2010 17:33'!
testPrimary
	
	self
		currentRule: #primary;
		
		assertMatches: '(self)';
		assertMatches: '(self/1)';
		assertMatches: '([self])';
		assertMatches: '([self.])';
		assertMatches: '([self2])';
		assertMatches: '(self2)' andProduces: (self node: 'paranthesizedExpression' with: { self node: 'identifier' with: { 'self2' }}).! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:35'!
testPrimitiveDeclaration
	
	self
		currentRule: #primitiveDeclaration;
		
		assertMatches: '<a:1b:1>';
		assertMatches: '<a>';
		assertMatches: '<  a>';
		assertMatches: '  <  a  >';
		assertMatches: '< | 1>';
		assertMatches: '< == 2>';
		assertMatches: '<  var: ''anc'' >';
		assertMatches: '< & ''add''>';
		assertMatches: '< abc: 22 dfe: 23>';
		
		assertFails: '<1>';
		assertFails: '< 1 2 >';
		assertFails: '<a: 1 1>';
		"assertFails: '<v: d>';" "These should not match, but match currently. Never mind, is not allowed by the compiler"
		"assertFails: '<d: 2 d: e>';"
		"assertFails: '< | d >';"
		assertFails: '<''2''>';
		assertFails: '<| 1>';
		assertFails: '<< 2>';
		assertFails: '< > 2>';
		assertFails: '<> 2>';
		assertFails: '< a: 2 ';
		assertFails: '< a ';
		assertFails: '< | 2 '.! !

!S2JParserTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:53'!
testStatements

	"TODO Not complete test !! Write more !! " 
	
	self
		currentRule: #statements;
		nilResultAllowed: true;
		
		assertMatches: '...';
		assertMatches: 'a. b. ^ c';
		assertMatches: 'a.b.c';
		assertMatches: '1 a. b d: d d: 1. 2. ^ a d: d f: 2';
		assertMatches: '  a  .  b   .. . . . .. . . . .   c.  ^ 1.';
		
		assertFails: ' a. ^ 1...';
		assertFails: ' 1. a ^ 1';
		assertFails: '^ d d. 1';
		assertFails: '^ .';
		assertFails: '^....';
		assertFails: '^^'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/1/2010 17:35'!
testString
	
	self
		currentRule: #string;
		
		assertMatches: '''a''' andProduces: (self node: 'string' with: { 'a' });
		assertMatches: '''''' andProduces: (self node: 'string' with: { '' });
		assertMatches: '''123''' andProduces: (self node: 'string' with: { '123' });
		assertMatches: ''' '''' '''' ''' andProduces: (self node: 'string' with: { ' '' '' ' });
		assertMatches: '''''''123''' andProduces: (self node: 'string' with: { '''123' });
		assertMatches: '''    ''' andProduces: (self node: 'string' with: { '    ' });
		assertMatches: '''"$%&''' andProduces: (self node: 'string' with: { '"$%&' });
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: ''' ''a';
		assertFails: ' ''''';
		assertFails: 'a''''';
		assertFails: '''as';
		assertFails: 'as''';
		assertFails: ''' '' ''';
		assertFails: '''a '' a''';
		assertFails: '''/'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 17:32'!
testSymbol
	
	"TODO extend test, if stringS2J gets extended to support '' inside of a string"
	
	self
		currentRule: #symbol;
		
		assertMatches: '#abc' andProducesNode: {#abc};
		assertMatches: '# ''''' andProducesNode: {#''};
		assertMatches: '#   abc' andProducesNode: {#  abc};
		assertMatches: '#abc1' andProducesNode: {#abc1};
		assertMatches: '#a' andProducesNode: {#a};
		assertMatches: '#''a''' andProducesNode: {#a};
		assertMatches: '#''a b c''' andProducesNode:  {#'a b c'};
		assertMatches: '#''''' andProducesNode: {#''};
		assertMatches: '#''123''' andProducesNode:  {#'123'};
		assertMatches: '#''    ''' andProducesNode: {#'    '};
		assertMatches: '#''"$%&''' andProducesNode: {#'"$%&'};
		assertMatches: '#abc1:' andProducesNode: {#abc1:};
		assertMatches: '#|' andProducesNode: {#|};
		assertMatches: '#-&&' andProducesNode: {#-&&};
		assertMatches: '#-' andProducesNode: {#-};
		assertMatches: '#a:b:c1' andProducesNode: {#a:b:c1};
		assertMatches: '#:' andProducesNode: {#:};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'abc';
		assertFails: '#1abc';
		assertFails: '#""';
		assertFails: '#'' ''a';
		assertFails: '#a''''';
		assertFails: '#''as';
		assertFails: '#as''';
		assertFails: '#'' '' ''';
		assertFails: '#''a '' a''';
		assertFails: '#123';
		assertFails: '###';
		assertFails: '#''/'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'LT 12/6/2010 11:38:46.1'!
testUnaryExpression
	
	self
		currentRule: #unaryExpression;
		
		assertMatches: 'a b' andProducesNode: { self node: 'identifier' with: {'a'}. #b };
		assertMatches: '1 b' andProducesNode: { self node: 'number' with: {1}. #b };
		assertMatches: 'a b c' andProducesNode: { self node: 'unaryExpression' 
			with: { self node: 'identifier' with: {'a'}. #b }. #c };
		assertMatches: ' a  b c d ' andProducesNode: { self node: 'unaryExpression' with: { self node: 'unaryExpression' with: { self node: 'identifier' with: {'a'}. #b }. #c }. #d };
		assertMatches: '   ''abc''    b1     ' andProducesNode: { self node: 'string' with: { 'abc' }. #b1 };
		
		assertFails: '';
		assertFails: '  ';
		assertFails: 'a';
		assertFails: '  a  ';
		assertFails: 'a  1';
		assertFails: 'a b 1';
		assertFails: 'a || b';
		assertFails: 'a % b';
		assertFails: 'a -|';
		assertFails: 'a b > a';
		assertFails: 'a unary>'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 10:08'!
testUnarySelector
	"Would be cool to find all the unary messages in the image and test them..."
	
	self
		currentRule: #unarySelector;
		
		assertMatches: 'abc' andProduces: #abc;
		assertMatches: 'a1' andProduces: #a1;
		assertMatches: '1' andProduces: #1;
		assertMatches: 'aaaaaaaa1233333' andProduces: #aaaaaaaa1233333;
		assertMatches: '' andProduces: #;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

S2JAbstractTest subclass: #S2JPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JPrinterTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:19'!
converterClass
	
	^ S2JPrinter! !

!S2JPrinterTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:25'!
defaultCurrentRule
	
	^ #statements! !

!S2JPrinterTest methodsFor: 'testing' stamp: 'ag 12/13/2010 09:21'!
expectedFailures
	
	^ #( testNonLocalReturn testClientEvaluation testExampleMethods )! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 15:32'!
testAddition
	
	self
		assertMatches: '3+4'
		andProduces: '3.$plus(4)'.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'HK 11/29/2010 16:31'!
testClientEvaluation

	self fail.
	"clientEval: [ JsGlobal alert: 3+4]"! !

!S2JPrinterTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 16:59'!
testLoop
	
	self
		assertMatches: '{1. 2. 3} do: [:elem | JsGlobal alert: elem]'
		andProduces: '[1, 2, 3].do$(function(elem){return alert(elem)})';
		
		assertMatches: 'arr do: [:elem | JsGlobal alert: elem ]'
		andProduces: 'arr.do$(function(elem){return alert(elem)})';
		
		assertMatches: 'arr do: block'
		andProduces: 'arr.do$(block)'.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 15:33'!
testNonLocalReturn
	
	self
		assertMatches: '
			[ JsGlobal alert: ''outer''.
			[JsGlobal alert: ''inner''.
			 ^self].
			JsGlobal alert: ''end'' ]'
		andProduces: ''
		"to be continued"! !

!S2JPrinterTest methodsFor: 'test printing' stamp: 'ag 12/13/2010 09:16'!
testPrinting
	
	self
		assert: '1 +/ 2' matches: #binaryExpression andProduces: '1.$plus$slash(2)';
		assert: '{ 1. a b: c. ''s'' }' matches: #braceExpression andProduces: '[1, a.b$(c), "s"]';
		assert: 'a :=   12 a: 12' matches: #expression andProduces: 'a=12.a$(12)';
		assert: '1 a: 2 b: 3' matches: #keywordExpression andProduces: '1.a$b$(2, 3)';
		assert: '1 a:a b:B. 2 s.' matches: #statements andProduces: '1.a$b$(a, B);2.s()';
		assert: '| a b v |' matches: #temporaries andProduces: 'var a;var b;var v;';
		assert: '1 bcd' matches: #unaryExpression andProduces: '1.bcd()';
		assert: '(1 2 3 ''d  '')' matches: #array andProduces: '[1, 2, 3, "d  "]';
		assert: '#[ 1 2 3 255]' matches: #byteArray andProduces: '[1, 2, 3, 255]';
		assert: '12.3' matches: #number andProduces: '12.3';
		assert: 'self' matches: #reservedWord andProduces: 'this';
		assert: '#a12' matches: #symbol andProduces: '"a12"';
		assert: '1 a: 2; b' matches: #cascadedExpression andProduces: 'var cascadeReceiver$=1;cascadeReceiver$.a$(2);cascadeReceiver$.b()'.! !

!S2JPrinterTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 15:38'!
testSelectorTranslation
	
	| assertBlock |
	assertBlock := [ :squeakSelector :jsFunctionname  | 
		self assert: jsFunctionname equals: (S2JSqueakAstToJsAst squeakSelectorToJSFunctionName: squeakSelector).].
	
	assertBlock
		value: 'do:forDuration:' value: 'do$forDuration$';
		value: 'do:' value: 'do$';
		value: 'do' value: 'do';
		value: '*+' value: '$times$plus';
		value: '++' value: '$plus$plus'.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 16:59'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ JsGlobal alert: ''small'' ] ifFalse: [ JsGlobal alert: ''big'' ]'
		andProduces:
			'10.$less(5).ifTrue$ifFalse$(function(){return alert("small")}, function(){return alert("big")})'! !

S2JAbstractTest subclass: #S2JSqueakAstToJsAstTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JSqueakAstToJsAstTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:19'!
converterClass
	
	^ S2JSqueakAstToJsAst! !

!S2JSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 17:44'!
testBlockArgument
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProduces: (self node: 'functionDeclaration' with: { self node: 'arguments'. self node: 'statements' });
		assertMatches: '[1]' andProduces: (self node: 'functionDeclaration' with: { self node: 'arguments'. self node: 'statements' with: 
			{ self node: 'returnExpression' with: { self node: 'number' with: { 1 }} }});
		assertMatches: '[^1]' andProduces: (self node: 'functionDeclaration' with: { self node: 'arguments'. self node: 'statements' with: 
			{ self node: 'nonlocalReturnExpression' with: { self node: 'number' with: { 1 }} }});
		assertMatches: '[:a]' andProduces: (self node: 'functionDeclaration' with: { self node: 'arguments' with: { self node: 'identifier' with: { 'a' }}. self node: 'statements' }).! !

!S2JSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!S2JSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 12/9/2010 17:56'!
testNonLocalReturn
	
	self
		currentRule: #block;
		
		assertMatches: 
			'[ [^ ''returned nonlocally''] value ]'
		 andProduces: (self node: 'functionDeclaration' with: 
			{ self node: 'functionCall' with: {
				nil.
				self node: 'functionDeclaration' with: {         }} })
		
		"
		function() {
			var block = function() {
				throw new NonLocalReturnError('returned nonlocally');
			};
			try {
				block();
			} catch(e) {
				if (e.constructor == NonLocalReturnError) {
					return e.value;
				} else {
					throw e;
				}
			}
		}
		"
		
		
		
		"
		var NonLocalReturnError = function(returnValue) {
			this.value = returnValue;
		}
		"! !

!S2JSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

Object subclass: #JsGlobal
	instanceVariableNames: 'testInstVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!JsGlobal commentStamp: 'lw 12/2/2010 18:43' prior: 0!
JsGlobal is a substitute for the JavaScript Global namespace. In order to call global JavaScript functions like alert, just send them to this Class.!

!JsGlobal methodsFor: 'as yet unclassified' stamp: 'ag 12/13/2010 15:48'!
alert: aString
	"This is mainly for testing"
	
	Transcript cr; show: aString.! !

Object subclass: #S2JClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/13/2010 15:42'!
convertClass: aClass withFunctions: functions to: output
	
	"This is the API to a S2JClassModel, the full javascript-definition of the class must be printed to aTextStream"
	
	"TODO"
	"TODO -- how to handle the print-mode (pretty print vs. obfuscation) here? It has already been handled during parsing?.."
	
	self subclassResponsibility! !

S2JClassModel subclass: #S2JFullClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/13/2010 17:04'!
convertClass: aClass withFunctions: functions to: output
	"Does not create a class, just a constructor-function, that sets all the functions."
	
	| instVars hasInstVars hasInstMethods |
	instVars := aClass allInstVarNames.
	hasInstVars := instVars notEmpty.
	hasInstMethods := functions notEmpty.
	output << aClass name << '=new Class({'.
	aClass superclass ifNotNil: [ 
		output << 'superClass:' << aClass superclass name.
		hasInstVars | hasInstMethods ifTrue: [ output << ',' ]].
	hasInstVars ifTrue: [
		output << 'instanceVariables:['.
		instVars do: [ :varName | 
			varName == instVars first ifFalse: [ output << ',' ].
			output << '''' << varName << ''''].
		output << ']'.
		hasInstMethods ifTrue: [ output << ',' ]].
	hasInstMethods ifTrue: [ | isFirst |
		output << 'instanceMethods:{'.
		isFirst := true.
		functions associationsDo: [ :function | 
			isFirst ifFalse: [ output << ',' ].
			isFirst := false.
			output << function key << ':' << function value].
		output << '}'].
	output << '})'.! !

S2JClassModel subclass: #S2JSimpleClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JSimpleClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/13/2010 15:51'!
convertClass: aClass withFunctions: functions to: output
	"Does not create a class, just a constructor-function, that sets all the functions."
	
	output << 'var ' << aClass name << '=function(){'.
	functions associationsDo: [ :function | output << 'this.' << function key << '=' << function value].
	output << '}'.! !

Object subclass: #S2JCodeFactory
	instanceVariableNames: 'codeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JCodeFactory class
	instanceVariableNames: 'instance textStream'!

S2JCodeFactory class
	instanceVariableNames: 'instance textStream'!

!S2JCodeFactory class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:58'!
classModelClass
	"Return the class-model-implementation, that will be used when parsing whole classes"
	
	^ S2JFullClassModel! !

!S2JCodeFactory class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:59'!
converterClass
	"Return the class, that is used to convert the code of methods and doIts"
	
	^ S2JPrinter! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 15:43'!
doesNotUnderstand: aMessage
	"removes need to call instance every time the code-factory is accessed"
	
	^ self instance perform: aMessage selector withArguments: aMessage arguments! !

!S2JCodeFactory class methodsFor: 'converting' stamp: 'ag 12/13/2010 14:46'!
getTextStream
	
	textStream reset.
	^ textStream! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 14:45'!
initialize
	
	super initialize.
	textStream := TextStream on: ''.! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 14:52'!
instance
	
	instance ifNil: [ instance := self new. self resetCodeCache ].
	^ instance! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 14:51'!
resetCodeCache
	
	self instance codeCache: Dictionary new.! !

!S2JCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache
	^ codeCache! !

!S2JCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache: anObject
	codeCache := anObject! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/13/2010 17:00'!
codeFor: aString
	"A simple DoIt-code-snippet"
	
	^ self
		getCodeFor: aString
		producedBy: [ (self class converterClass convertDoIt: aString) value ].! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/13/2010 17:00'!
codeForClass: aClassOrClassName
	"A JS-Code-String representing the whole class. Without a DoIt code-snippet etc."
	
	| cl |
	cl := self class converterClass classNamed: aClassOrClassName.
	^ self
		getCodeFor: cl
		producedBy: [ self convertCodeForClass: cl ]! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/13/2010 17:00'!
codeForCompiledMethod: aCompiledMethod
	"An association from the function-name to the function-declaration-code"
	
	^ self
		getCodeFor: aCompiledMethod
		producedBy: [ self class converterClass convertCompiledMethod: aCompiledMethod ]! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/13/2010 17:00'!
codeForMethod: aMethodSelector of: aClassOrClassName
	
	^ self codeForCompiledMethod: (self class converterClass method: aMethodSelector of: aClassOrClassName)! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/13/2010 17:16'!
convertCodeForClass: aClass
	
	"TODO this ignores class-side methods ??"
	
	| output functions |
	functions := self class converterClass convertAllMethodsOf: aClass.
	output := self class getTextStream.
	self class classModelClass
		convertClass: aClass
		withFunctions: functions
		to: output.
	^ output contents! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/13/2010 15:25'!
getCodeFor: anObject producedBy: aBlock
	
	| result |
	result := self codeCache at: anObject ifAbsent: [ nil ].
	(result isNil or: [ self hasChanged: anObject ])
		ifTrue: [
			result := aBlock value.
			self codeCache at: anObject put: result].
	^ result! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/13/2010 15:25'!
hasChanged: anObject
	
	"TODO find a way to check, whether a method / class (one of it's method etc.) has changed after last time it has been converted."
	"anObject can be a Class or a CompiledMethod"
	
	^ false! !

Object subclass: #S2JUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JUtils class methodsFor: 'grepping' stamp: 'ag 12/13/2010 13:50'!
grep: aString
	"Search the source-code of our packages and return a collection of all CompiledMethods, that contain aString in their source-code."
	
	| methods packages |
	methods := OrderedCollection new.
	packages := PackageOrganizer default.
	self ourPackages do: [ :packageName | | package |
		package := packages packageNamed: packageName ifAbsent: [ nil ].
		package ifNotNil: [
			package actualMethodsDo: [ :method |
				(method getSource asString includesSubString: aString)
					ifTrue: [ methods add: method ]]]].
	^ methods! !

!S2JUtils class methodsFor: 'grepping' stamp: 'ag 12/13/2010 13:35'!
ourPackages
	
	^ #( 'Squeak2JS' 'SwazooSpike' )! !

OrderedCollection subclass: #S2JNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JNode commentStamp: 'ag 11/18/2010 13:09' prior: 0!
This is only a named collection, that is supposed to hold further collections or strings to form a tree!

!S2JNode class methodsFor: 'helpers' stamp: 'ag 12/1/2010 16:20'!
concatenate: anOrderedCollection separatedBy: aString
	
	^ anOrderedCollection 
		inject: '' 
		into: 
			[ :sum :each | 
				sum isEmpty 
					ifTrue: [each asString] 
					ifFalse: [sum, aString, each asString]]! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:08'!
named: aString with: anOrderedCollection
	
	^ self new
		name: aString;
		addAll: anOrderedCollection;
		yourself! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:58'!
named: aString withoutNils: anOrderedCollection
	
	anOrderedCollection ifNil: [ ^ nil ].
	^ self
		named: aString
		with: (anOrderedCollection reject: [ :each | each isNil])! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/21/2010 19:15'!
named: aString withoutNilsNotEmpty: anOrderedCollection
	"Returns nil, if resulting node would be empty"
	
	| result |
	result := self named: aString withoutNils: anOrderedCollection.
	^ (result isNil or: [result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!S2JNode methodsFor: 'comparing' stamp: 'ag 11/21/2010 19:19'!
= anObject
	
	^ super = anObject and: 
		[ name = anObject name ]! !

!S2JNode methodsFor: 'testing' stamp: 'LT 12/1/2010 14:06:25.154'!
isArrayNode

	^ name = 'array' or: [name = 'byteArray' or: [name = 'braceExpression']]! !

!S2JNode methodsFor: 'accessors' stamp: 'ag 11/18/2010 13:07'!
name
	
	^ name! !

!S2JNode methodsFor: 'accessors' stamp: 'ag 11/18/2010 13:07'!
name: aString
	
	name := aString! !

!S2JNode methodsFor: 'printing' stamp: 'ag 11/19/2010 00:39'!
printString
	
	| result first |
	first := true.
	result := name, ' ('.
	self do: [ :each |
		first ifTrue: [first := false] ifFalse: [result := result, ', '].
		result := result,  each printString].
	^ result, ')'! !
S2JCodeFactory initialize!
